var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//NPM
import React from 'react';
import { StyleSheet, css } from 'aphrodite';
import { useDropzone } from 'react-dropzone';

var DropZoneButton = function (_React$Component) {
  _inherits(DropZoneButton, _React$Component);

  function DropZoneButton(props) {
    _classCallCheck(this, DropZoneButton);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.handleDrop = function (e) {
      var files = e.dataTransfer.files;
      _this.props.appendFile(files);
    };

    _this.promptImageUpload = function (e) {
      var input = document.getElementById('input');
      input.click();
    };

    _this.handleInputChange = function (e) {
      var fileList = e.target.files;
      _this.props.appendFile(fileList);
    };

    _this.state = {
      switch: true //leaving possibility for user to delete image when dropped
    };
    return _this;
  }

  /**
   * Allows user to add image that are dragged on top of button 
   * @param { Event } e -- allows data from image to be saved onDrop
   * @function { appendFile } -- function on parent that adds the file to cache and to image array
   */


  /**
   * Allows user to access the file input
   * @param { Event } e -- triggers synthetic event onClick
   */


  /**
   * Allows images that selected in input window to be saved
   * @param { Event } e -- the file/files chosen by the user onChange
   * @function { appendFile } -- function on parent that adds the file to cache and to image array
   */


  DropZoneButton.prototype.render = function render() {
    var _useDropzone = useDropzone(),
        getRootProps = _useDropzone.getRootProps,
        getInputProps = _useDropzone.getInputProps;

    return React.createElement(
      'div',
      _extends({
        className: css(styles.buttonWrapper),
        onClick: this.promptImageUpload
      }, getRootProps()),
      React.createElement('input', _extends({ className: css(styles.input),
        type: 'file',
        multiple: true,
        accept: 'image/*'
      }, getInputProps())),
      React.createElement(
        'div',
        { className: css(styles.button) },
        React.createElement(
          'p',
          { className: css(styles.plus) },
          '+'
        )
      )
    );
  };

  return DropZoneButton;
}(React.Component);

export { DropZoneButton as default };


var styles = StyleSheet.create({
  buttonWrapper: {
    display: "flex",
    flexDirection: "column",
    justifyContent: "center",
    alignItems: "center",
    height: 90,
    width: 90,
    borderRadius: "50%",
    color: "black",
    cursor: "pointer",
    userSelect: "none",
    lineHeight: 1.5,
    float: "left",
    marginLeft: 15,
    marginRight: 15,
    boxShadow: 'rgba(129,148,167,0.39) 0px 3px 10px 0px'
  },
  input: {
    display: "none"
  },
  plus: {
    float: "left",
    margin: "0",
    fontSize: 40
  }
});