//NPM
import React from 'react';
import { StyleSheet, css } from 'aphrodite';

//Component
import FinishedScreenPreview from './FinishedScreenPreview';

var FinishedScreen = function FinishedScreen(_ref) {
  var images = _ref.images;

  return React.createElement(
    'div',
    { className: css(styles.FinishedScreen) },
    React.createElement(
      'h1',
      { className: css(styles.Text) },
      'Successfully Submitted'
    ),
    React.createElement(
      'div',
      { className: css(styles.ImageReview) },
      images.map(function (image, index) {
        var src = window.URL.createObjectURL(image); //creates src from image object
        return React.createElement(FinishedScreenPreview, { src: src, key: index });
      })
    )
  );
};

var styles = StyleSheet.create({
  FinishedScreen: {
    height: "100%",
    width: "80%",
    display: "flex",
    flexDirection: "column",
    justifyContent: "space-between",
    alignContent: "center",
    overflowX: "scroll",
    overflowY: "hidden",
    paddingBottom: 5
  },
  Text: {
    margin: "auto",
    fontWeight: 400
  },
  ImageReview: {
    display: "flex",
    flexDirection: "row",
    justifyContent: "flex-start",
    height: "70%",
    overflowX: "scroll",
    overflowY: "hidden"
  }
});

export default FinishedScreen;