'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _aphrodite = require('aphrodite');

var _FinishedScreenPreview = require('./FinishedScreenPreview');

var _FinishedScreenPreview2 = _interopRequireDefault(_FinishedScreenPreview);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FinishedScreen = function FinishedScreen(_ref) {
  var images = _ref.images;

  return _react2.default.createElement(
    'div',
    { className: (0, _aphrodite.css)(styles.FinishedScreen) },
    _react2.default.createElement(
      'h1',
      { className: (0, _aphrodite.css)(styles.Text) },
      'Successfully Submitted'
    ),
    _react2.default.createElement(
      'div',
      { className: (0, _aphrodite.css)(styles.ImageReview) },
      images.map(function (image, index) {
        var src = window.URL.createObjectURL(image); //creates src from image object
        return _react2.default.createElement(_FinishedScreenPreview2.default, { src: src, key: index });
      })
    )
  );
};

//Component
//NPM


var styles = _aphrodite.StyleSheet.create({
  FinishedScreen: {
    height: "100%",
    width: "80%",
    display: "flex",
    flexDirection: "column",
    justifyContent: "space-between",
    alignContent: "center",
    overflowX: "scroll",
    overflowY: "hidden",
    paddingBottom: 5
  },
  Text: {
    margin: "auto",
    fontWeight: 400
  },
  ImageReview: {
    display: "flex",
    flexDirection: "row",
    justifyContent: "flex-start",
    height: "70%",
    overflowX: "scroll",
    overflowY: "hidden"
  }
});

exports.default = FinishedScreen;
module.exports = exports['default'];