'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSortableHoc = require('react-sortable-hoc');

var _aphrodite = require('aphrodite');

var _SortableItem = require('./SortableItem');

var _SortableItem2 = _interopRequireDefault(_SortableItem);

var _DropZoneHero = require('./DropZoneHero');

var _DropZoneHero2 = _interopRequireDefault(_DropZoneHero);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Component
var SortableList = (0, _reactSortableHoc.SortableContainer)(function (props) {
  var images = props.images,
      handleDrop = props.handleDrop,
      removeFile = props.removeFile,
      blobs = props.blobs,
      imageClassName = props.imageClassName,
      imageContainerClassName = props.imageContainerClassName;

  return _react2.default.createElement(
    'div',
    { className: (0, _aphrodite.css)(styles.DropZoneGrid) },
    images.length && images.map(function (image, i) {
      var name = image.name,
          lastModified = image.lastModified,
          type = image.type; // uses this as a unique key and id

      var uid = name && lastModified ? name + lastModified : image.id;
      var src = blobs[uid] ? blobs[uid] : image.url; // creates src from image data 
      var many = images.length > 2 ? true : false; // determines the css (size) of dropzones

      return _react2.default.createElement(_SortableItem2.default, {
        index: i,
        image: image,
        id: uid,
        key: uid,
        src: src,
        imageContainerClassName: imageContainerClassName,
        imageClassName: imageClassName,
        handleDrop: handleDrop,
        removeFile: removeFile,
        many: many,
        isPdf: type === 'application/pdf'
      });
    }),
    _react2.default.createElement(_DropZoneHero2.default, {
      images: images,
      id: 0,
      addImageClassName: props.addImageClassName,
      blobs: props.blobs,
      saveBlob: props.saveBlob,
      appendFile: props.appendFile,
      removeFile: props.removeFile,
      onSortEnd: props.onSortEnd,
      handleDrop: props.handleDrop,
      addImageText: props.addImageText,
      fileAccept: props.fileAccept
    })
  );
}); // NPM


var styles = _aphrodite.StyleSheet.create({
  DropZoneGrid: {
    display: "flex",
    flexDirection: "row",
    justifyContent: "center",
    alignItems: "center",
    flexWrap: "wrap",
    background: "rbga(248,248,248,0.8)",
    overflowY: "scroll",
    width: '100%',
    ":-webkit-scrollbar": {
      display: "none",
      width: 0
    }
  }
});

exports.default = SortableList;
module.exports = exports['default'];